# label vacancies with dummy element "X"
from ase.io import read, write
from ase import Atoms
from ase.db             import connect
from ase.neighborlist import build_neighbor_list, NewPrimitiveNeighborList
from ase.atom import Atom

reference = read('PRIM.POSCAR', format='vasp')
vcar = reference.get_positions()
vd1 = vcar[0] - vcar[3]
vd2 = vcar[1] - vcar[3]
vd3 = vcar[2] - vcar[3]
vds = [vd1, vd2, vd3]
'''
target_db_path = 'target.db'
# Load target structure from KMC
target_db = connect(target_db_path)
for row in target_db.select():
    structure = row.toatoms()
'''

#pathi = '/p/lustre1/xiao2/KMC/NiCrO/moving_sink_alloymatrix/src_reprecipitate/test_CE122120/300K_sol9/Cr20_0.71V_solL9/a128_ruby7/tmp76.vasp'
#pathi = '/p/lustre1/xiao2/KMC/NiCrO/moving_sink_alloymatrix/src_reprecipitate/test_CE122120/400K_sol9/Cr20_0.5V_solL9/tmp66.vasp'
#pathi = '/p/lustre1/xiao2/KMC/NiCrO/moving_sink_alloymatrix/src_reprecipitate/test_CE122120/400K_sol9/Cr20_0.65V_solL9/a128_borax2/tmp101.vasp'
#pathi = '/p/lustre1/xiao2/KMC/NiCrO/moving_sink_alloymatrix/src_reprecipitate/test_CE122120/400K_sol9/Cr20_0.9V_solL9/tmp27.vasp'
pathi = '/p/lustre1/xiao2/KMC/NiCrO/moving_sink_alloymatrix/src_reprecipitate/test_CE122120/400K_sol9/Cr20_0.8V_solL9/tmp21.vasp'
structure = read(pathi, format='vasp')
'''
# cut the big supercell into small parts
'''
vdir= structure.get_scaled_positions()
'''
struc_slice = Atoms()
frac = 64/128.0
a0   = 64/128.0
box = structure.get_cell()
box[0] *= frac
for atom in structure:
   i = atom.index
   xin = vdir[i][0] < frac-0.01+a0 and vdir[i][0] > a0-0.01
   if xin : struc_slice += structure[i]
struc_slice.set_cell(box)
struc_slice.set_pbc([1,1,1])
'''
struc_slice = structure

# add X
for atomi in struc_slice:
    if atomi.symbol != 'O': continue
    pos0 = atomi.position
    for displacement in vds:
       newX = Atom('X', position=pos0+displacement)
       struc_slice += newX
# remove those X too close to Cr/Ni
nl = build_neighbor_list(struc_slice, cutoffs=[0.1]*len(struc_slice), self_interaction=False, primitive=NewPrimitiveNeighborList, bothways = True)
remove_list = []
for i in range(len(struc_slice)):
   if struc_slice[i].symbol == 'X': 
      indices, offsets = nl.get_neighbors(i)
      if len(indices) > 0: remove_list.append(i)
del struc_slice[remove_list]
#write('slice_X_0.77V.vasp', struc_slice, format='vasp', vasp5=True, direct=True)
#write('slice_X_400K_0.5V.vasp', struc_slice, format='vasp', vasp5=True, direct=True)
#write('slice_X_400K_0.65V.vasp', struc_slice, format='vasp', vasp5=True, direct=True)
#write('slice_X_400K_0.9V.vasp', struc_slice, format='vasp', vasp5=True, direct=True)
write('slice_X_400K_0.8V.vasp', struc_slice, format='vasp', vasp5=True, direct=True)
